import{S as ia,i as la,s as ca,e as n,k as m,w as b,t as s,M as pa,c as a,d as o,m as h,a as r,x as w,h as i,b as l,N as fa,G as t,g as p,y,q as $,o as N,B as S,v as ma,L as sa}from"../../chunks/vendor-hf-doc-builder.js";import{T as ha}from"../../chunks/Tip-hf-doc-builder.js";import{D as Ht}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Wt}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Je}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as ra}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function da(R){let d,k,g,u,v;return u=new Wt({props:{code:`from transformers import UperNetConfig, UperNetForSemanticSegmentation

# Initializing a configuration
configuration = UperNetConfig()

# Initializing a model (with random weights) from the configuration
model = UperNetForSemanticSegmentation(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> UperNetConfig, UperNetForSemanticSegmentation

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = UperNetConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = UperNetForSemanticSegmentation(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){d=n("p"),k=s("Examples:"),g=m(),b(u.$$.fragment)},l(f){d=a(f,"P",{});var _=r(d);k=i(_,"Examples:"),_.forEach(o),g=h(f),w(u.$$.fragment,f)},m(f,_){p(f,d,_),t(d,k),p(f,g,_),y(u,f,_),v=!0},p:sa,i(f){v||($(u.$$.fragment,f),v=!0)},o(f){N(u.$$.fragment,f),v=!1},d(f){f&&o(d),f&&o(g),S(u,f)}}}function ua(R){let d,k,g,u,v;return{c(){d=n("p"),k=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=n("code"),u=s("Module"),v=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(f){d=a(f,"P",{});var _=r(d);k=i(_,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=a(_,"CODE",{});var H=r(g);u=i(H,"Module"),H.forEach(o),v=i(_,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),_.forEach(o)},m(f,_){p(f,d,_),t(d,k),t(d,g),t(g,u),t(d,v)},d(f){f&&o(d)}}}function ga(R){let d,k,g,u,v;return u=new Wt({props:{code:`from transformers import AutoImageProcessor, UperNetForSemanticSegmentation
from PIL import Image
from huggingface_hub import hf_hub_download

image_processor = AutoImageProcessor.from_pretrained("openmmlab/upernet-convnext-tiny")
model = UperNetForSemanticSegmentation.from_pretrained("openmmlab/upernet-convnext-tiny")

filepath = hf_hub_download(
    repo_id="hf-internal-testing/fixtures_ade20k", filename="ADE_val_00000001.jpg", repo_type="dataset"
)
image = Image.open(filepath).convert("RGB")

inputs = image_processor(images=image, return_tensors="pt")

outputs = model(**inputs)

logits = outputs.logits  # shape (batch_size, num_labels, height, width)
list(logits.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, UperNetForSemanticSegmentation
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> hf_hub_download

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;openmmlab/upernet-convnext-tiny&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = UperNetForSemanticSegmentation.from_pretrained(<span class="hljs-string">&quot;openmmlab/upernet-convnext-tiny&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>filepath = hf_hub_download(
<span class="hljs-meta">... </span>    repo_id=<span class="hljs-string">&quot;hf-internal-testing/fixtures_ade20k&quot;</span>, filename=<span class="hljs-string">&quot;ADE_val_00000001.jpg&quot;</span>, repo_type=<span class="hljs-string">&quot;dataset&quot;</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(filepath).convert(<span class="hljs-string">&quot;RGB&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits  <span class="hljs-comment"># shape (batch_size, num_labels, height, width)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">list</span>(logits.shape)
[<span class="hljs-number">1</span>, <span class="hljs-number">150</span>, <span class="hljs-number">512</span>, <span class="hljs-number">512</span>]`}}),{c(){d=n("p"),k=s("Examples:"),g=m(),b(u.$$.fragment)},l(f){d=a(f,"P",{});var _=r(d);k=i(_,"Examples:"),_.forEach(o),g=h(f),w(u.$$.fragment,f)},m(f,_){p(f,d,_),t(d,k),p(f,g,_),y(u,f,_),v=!0},p:sa,i(f){v||($(u.$$.fragment,f),v=!0)},o(f){N(u.$$.fragment,f),v=!1},d(f){f&&o(d),f&&o(g),S(u,f)}}}function _a(R){let d,k,g,u,v,f,_,H,Bt,ft,F,W,Ye,re,Xt,Ve,Gt,mt,x,Jt,se,Yt,Vt,Ue,Zt,Kt,xe,Qt,eo,ht,Pe,to,dt,Ee,Ze,oo,ut,B,un,gt,X,no,Ce,ao,ro,_t,C,so,ie,io,lo,le,co,po,vt,A,G,Ke,ce,fo,Qe,mo,bt,je,ho,wt,J,pe,uo,fe,go,_o,vo,j,Te,bo,wo,me,yo,$o,he,No,So,yt,Fe,ko,$t,q,Y,et,de,Uo,tt,xo,Nt,Ae,Po,St,ue,kt,V,Eo,qe,Co,jo,Ut,ge,xt,ze,To,Pt,z,Z,ot,_e,Fo,nt,Ao,Et,U,ve,qo,I,zo,Ie,Io,Do,be,Oo,Mo,Lo,D,Ro,De,Ho,Wo,Oe,Bo,Xo,Go,K,Jo,Q,we,Yo,O,Vo,Me,Zo,Ko,at,Qo,en,Ct,M,ee,rt,ye,tn,st,on,jt,E,$e,nn,it,an,rn,P,Ne,sn,L,ln,Le,cn,pn,lt,fn,mn,hn,te,dn,oe,Tt;return f=new Je({}),re=new Je({}),ce=new Je({}),de=new Je({}),ue=new Wt({props:{code:`from transformers import SwinConfig, UperNetConfig, UperNetForSemanticSegmentation

backbone_config = SwinConfig(out_features=["stage1", "stage2", "stage3", "stage4"])

config = UperNetConfig(backbone_config=backbone_config)
model = UperNetForSemanticSegmentation(config)`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> SwinConfig, UperNetConfig, UperNetForSemanticSegmentation

backbone_config = SwinConfig(out_features=[<span class="hljs-string">&quot;stage1&quot;</span>, <span class="hljs-string">&quot;stage2&quot;</span>, <span class="hljs-string">&quot;stage3&quot;</span>, <span class="hljs-string">&quot;stage4&quot;</span>])

config = UperNetConfig(backbone_config=backbone_config)
model = UperNetForSemanticSegmentation(config)`}}),ge=new Wt({props:{code:`from transformers import ConvNextConfig, UperNetConfig, UperNetForSemanticSegmentation

backbone_config = ConvNextConfig(out_features=["stage1", "stage2", "stage3", "stage4"])

config = UperNetConfig(backbone_config=backbone_config)
model = UperNetForSemanticSegmentation(config)`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> ConvNextConfig, UperNetConfig, UperNetForSemanticSegmentation

backbone_config = ConvNextConfig(out_features=[<span class="hljs-string">&quot;stage1&quot;</span>, <span class="hljs-string">&quot;stage2&quot;</span>, <span class="hljs-string">&quot;stage3&quot;</span>, <span class="hljs-string">&quot;stage4&quot;</span>])

config = UperNetConfig(backbone_config=backbone_config)
model = UperNetForSemanticSegmentation(config)`}}),_e=new Je({}),ve=new Ht({props:{name:"class transformers.UperNetConfig",anchor:"transformers.UperNetConfig",parameters:[{name:"backbone_config",val:" = None"},{name:"hidden_size",val:" = 512"},{name:"initializer_range",val:" = 0.02"},{name:"pool_scales",val:" = [1, 2, 3, 6]"},{name:"use_auxiliary_head",val:" = True"},{name:"auxiliary_loss_weight",val:" = 0.4"},{name:"auxiliary_in_channels",val:" = 384"},{name:"auxiliary_channels",val:" = 256"},{name:"auxiliary_num_convs",val:" = 1"},{name:"auxiliary_concat_input",val:" = False"},{name:"loss_ignore_index",val:" = 255"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.UperNetConfig.backbone_config",description:`<strong>backbone_config</strong> (<code>PretrainedConfig</code> or <code>dict</code>, <em>optional</em>, defaults to <code>ResNetConfig()</code>) &#x2014;
The configuration of the backbone model.`,name:"backbone_config"},{anchor:"transformers.UperNetConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 512) &#x2014;
The number of hidden units in the convolutional layers.`,name:"hidden_size"},{anchor:"transformers.UperNetConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.UperNetConfig.pool_scales",description:`<strong>pool_scales</strong> (<code>Tuple[int]</code>, <em>optional</em>, defaults to <code>[1, 2, 3, 6]</code>) &#x2014;
Pooling scales used in Pooling Pyramid Module applied on the last feature map.`,name:"pool_scales"},{anchor:"transformers.UperNetConfig.use_auxiliary_head",description:`<strong>use_auxiliary_head</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to use an auxiliary head during training.`,name:"use_auxiliary_head"},{anchor:"transformers.UperNetConfig.auxiliary_loss_weight",description:`<strong>auxiliary_loss_weight</strong> (<code>float</code>, <em>optional</em>, defaults to 0.4) &#x2014;
Weight of the cross-entropy loss of the auxiliary head.`,name:"auxiliary_loss_weight"},{anchor:"transformers.UperNetConfig.auxiliary_channels",description:`<strong>auxiliary_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Number of channels to use in the auxiliary head.`,name:"auxiliary_channels"},{anchor:"transformers.UperNetConfig.auxiliary_num_convs",description:`<strong>auxiliary_num_convs</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Number of convolutional layers to use in the auxiliary head.`,name:"auxiliary_num_convs"},{anchor:"transformers.UperNetConfig.auxiliary_concat_input",description:`<strong>auxiliary_concat_input</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to concatenate the output of the auxiliary head with the input before the classification layer.`,name:"auxiliary_concat_input"},{anchor:"transformers.UperNetConfig.loss_ignore_index",description:`<strong>loss_ignore_index</strong> (<code>int</code>, <em>optional</em>, defaults to 255) &#x2014;
The index that is ignored by the loss function.`,name:"loss_ignore_index"}],source:"https://github.com/huggingface/transformers/blob/v4.26.1/src/transformers/models/upernet/configuration_upernet.py#L27"}}),K=new ra({props:{anchor:"transformers.UperNetConfig.example",$$slots:{default:[da]},$$scope:{ctx:R}}}),we=new Ht({props:{name:"to_dict",anchor:"transformers.UperNetConfig.to_dict",parameters:[],source:"https://github.com/huggingface/transformers/blob/v4.26.1/src/transformers/models/upernet/configuration_upernet.py#L112"}}),ye=new Je({}),$e=new Ht({props:{name:"class transformers.UperNetForSemanticSegmentation",anchor:"transformers.UperNetForSemanticSegmentation",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.UperNetForSemanticSegmentation.This",description:"<strong>This</strong> model is a PyTorch [torch.nn.Module](https &#x2014;//pytorch.org/docs/stable/nn.html#torch.nn.Module) sub-class. Use",name:"This"},{anchor:"transformers.UperNetForSemanticSegmentation.it",description:`<strong>it</strong> as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and &#x2014;
behavior. &#x2014;
config (<a href="/docs/transformers/v4.26.1/en/model_doc/upernet#transformers.UperNetConfig">UperNetConfig</a>): Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/v4.26.1/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"it"}],source:"https://github.com/huggingface/transformers/blob/v4.26.1/src/transformers/models/upernet/modeling_upernet.py#L345"}}),Ne=new Ht({props:{name:"forward",anchor:"transformers.UperNetForSemanticSegmentation.forward",parameters:[{name:"pixel_values",val:": typing.Optional[torch.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Optional[torch.Tensor] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.UperNetForSemanticSegmentation.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Padding will be ignored by default should you provide it. Pixel values can be obtained using
<a href="/docs/transformers/v4.26.1/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See <a href="/docs/transformers/v4.26.1/en/model_doc/segformer#transformers.SegformerFeatureExtractor.__call__">SegformerImageProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.UperNetForSemanticSegmentation.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers in case the backbone has them. See
<code>attentions</code> under returned tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.UperNetForSemanticSegmentation.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers of the backbone. See <code>hidden_states</code> under
returned tensors for more detail.`,name:"output_hidden_states"},{anchor:"transformers.UperNetForSemanticSegmentation.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/v4.26.1/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.UperNetForSemanticSegmentation.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Ground truth semantic segmentation maps for computing the loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels &gt; 1</code>, a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/v4.26.1/src/transformers/models/upernet/modeling_upernet.py#L358",returnDescription:`
<p>A <a
  href="/docs/transformers/v4.26.1/en/main_classes/output#transformers.modeling_outputs.SemanticSegmenterOutput"
>transformers.modeling_outputs.SemanticSegmenterOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/v4.26.1/en/model_doc/upernet#transformers.UperNetConfig"
>UperNetConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.num_labels, logits_height, logits_width)</code>) \u2014 Classification scores for each pixel.</p>
<Tip warning={true}>
<p>The logits returned do not necessarily have the same size as the <code>pixel_values</code> passed as inputs. This is
to avoid doing two interpolations and lose some quality when a user needs to resize the logits to the
original image size as post-processing. You should always check your logits shape and resize as needed.</p>
</Tip>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, patch_size, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, patch_size, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/v4.26.1/en/main_classes/output#transformers.modeling_outputs.SemanticSegmenterOutput"
>transformers.modeling_outputs.SemanticSegmenterOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),te=new ha({props:{$$slots:{default:[ua]},$$scope:{ctx:R}}}),oe=new ra({props:{anchor:"transformers.UperNetForSemanticSegmentation.forward.example",$$slots:{default:[ga]},$$scope:{ctx:R}}}),{c(){d=n("meta"),k=m(),g=n("h1"),u=n("a"),v=n("span"),b(f.$$.fragment),_=m(),H=n("span"),Bt=s("UPerNet"),ft=m(),F=n("h2"),W=n("a"),Ye=n("span"),b(re.$$.fragment),Xt=m(),Ve=n("span"),Gt=s("Overview"),mt=m(),x=n("p"),Jt=s("The UPerNet model was proposed in "),se=n("a"),Yt=s("Unified Perceptual Parsing for Scene Understanding"),Vt=s(`
by Tete Xiao, Yingcheng Liu, Bolei Zhou, Yuning Jiang, Jian Sun. UPerNet is a general framework to effectively segment
a wide range of concepts from images, leveraging any vision backbone like `),Ue=n("a"),Zt=s("ConvNeXt"),Kt=s(" or "),xe=n("a"),Qt=s("Swin"),eo=s("."),ht=m(),Pe=n("p"),to=s("The abstract from the paper is the following:"),dt=m(),Ee=n("p"),Ze=n("em"),oo=s("Humans recognize the visual world at multiple levels: we effortlessly categorize scenes and detect objects inside, while also identifying the textures and surfaces of the objects along with their different compositional parts. In this paper, we study a new task called Unified Perceptual Parsing, which requires the machine vision systems to recognize as many visual concepts as possible from a given image. A multi-task framework called UPerNet and a training strategy are developed to learn from heterogeneous image annotations. We benchmark our framework on Unified Perceptual Parsing and show that it is able to effectively segment a wide range of concepts from images. The trained networks are further applied to discover visual knowledge in natural scenes."),ut=m(),B=n("img"),gt=m(),X=n("small"),no=s("UPerNet framework. Taken from the "),Ce=n("a"),ao=s("original paper"),ro=s("."),_t=m(),C=n("p"),so=s("This model was contributed by "),ie=n("a"),io=s("nielsr"),lo=s(". The original code is based on OpenMMLab\u2019s mmsegmentation "),le=n("a"),co=s("here"),po=s("."),vt=m(),A=n("h2"),G=n("a"),Ke=n("span"),b(ce.$$.fragment),fo=m(),Qe=n("span"),mo=s("Resources"),bt=m(),je=n("p"),ho=s("A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with UPerNet."),wt=m(),J=n("ul"),pe=n("li"),uo=s("Demo notebooks for UPerNet can be found "),fe=n("a"),go=s("here"),_o=s("."),vo=m(),j=n("li"),Te=n("a"),bo=s("UperNetForSemanticSegmentation"),wo=s(" is supported by this "),me=n("a"),yo=s("example script"),$o=s(" and "),he=n("a"),No=s("notebook"),So=s("."),yt=m(),Fe=n("p"),ko=s("If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),$t=m(),q=n("h2"),Y=n("a"),et=n("span"),b(de.$$.fragment),Uo=m(),tt=n("span"),xo=s("Usage"),Nt=m(),Ae=n("p"),Po=s("UPerNet is a general framework for semantic segmentation. It can be used with any vision backbone, like so:"),St=m(),b(ue.$$.fragment),kt=m(),V=n("p"),Eo=s("To use another vision backbone, like "),qe=n("a"),Co=s("ConvNeXt"),jo=s(", simply instantiate the model with the appropriate backbone:"),Ut=m(),b(ge.$$.fragment),xt=m(),ze=n("p"),To=s("Note that this will randomly initialize all the weights of the model."),Pt=m(),z=n("h2"),Z=n("a"),ot=n("span"),b(_e.$$.fragment),Fo=m(),nt=n("span"),Ao=s("UperNetConfig"),Et=m(),U=n("div"),b(ve.$$.fragment),qo=m(),I=n("p"),zo=s("This is the configuration class to store the configuration of an "),Ie=n("a"),Io=s("UperNetForSemanticSegmentation"),Do=s(`. It is used to
instantiate an UperNet model according to the specified arguments, defining the model architecture. Instantiating a
configuration with the defaults will yield a similar configuration to that of the UperNet
`),be=n("a"),Oo=s("openmmlab/upernet-convnext-tiny"),Mo=s(" architecture."),Lo=m(),D=n("p"),Ro=s("Configuration objects inherit from "),De=n("a"),Ho=s("PretrainedConfig"),Wo=s(` and can be used to control the model outputs. Read the
documentation from `),Oe=n("a"),Bo=s("PretrainedConfig"),Xo=s(" for more information."),Go=m(),b(K.$$.fragment),Jo=m(),Q=n("div"),b(we.$$.fragment),Yo=m(),O=n("p"),Vo=s("Serializes this instance to a Python dictionary. Override the default "),Me=n("a"),Zo=s("to_dict()"),Ko=s(`. Returns:
`),at=n("code"),Qo=s("Dict[str, any]"),en=s(": Dictionary of all the attributes that make up this configuration instance,"),Ct=m(),M=n("h2"),ee=n("a"),rt=n("span"),b(ye.$$.fragment),tn=m(),st=n("span"),on=s("UperNetForSemanticSegmentation"),jt=m(),E=n("div"),b($e.$$.fragment),nn=m(),it=n("p"),an=s("UperNet framework leveraging any vision backbone e.g. for ADE20k, CityScapes."),rn=m(),P=n("div"),b(Ne.$$.fragment),sn=m(),L=n("p"),ln=s("The "),Le=n("a"),cn=s("UperNetForSemanticSegmentation"),pn=s(" forward method, overrides the "),lt=n("code"),fn=s("__call__"),mn=s(" special method."),hn=m(),b(te.$$.fragment),dn=m(),b(oe.$$.fragment),this.h()},l(e){const c=pa('[data-svelte="svelte-1phssyn"]',document.head);d=a(c,"META",{name:!0,content:!0}),c.forEach(o),k=h(e),g=a(e,"H1",{class:!0});var Se=r(g);u=a(Se,"A",{id:!0,class:!0,href:!0});var ct=r(u);v=a(ct,"SPAN",{});var pt=r(v);w(f.$$.fragment,pt),pt.forEach(o),ct.forEach(o),_=h(Se),H=a(Se,"SPAN",{});var gn=r(H);Bt=i(gn,"UPerNet"),gn.forEach(o),Se.forEach(o),ft=h(e),F=a(e,"H2",{class:!0});var Ft=r(F);W=a(Ft,"A",{id:!0,class:!0,href:!0});var _n=r(W);Ye=a(_n,"SPAN",{});var vn=r(Ye);w(re.$$.fragment,vn),vn.forEach(o),_n.forEach(o),Xt=h(Ft),Ve=a(Ft,"SPAN",{});var bn=r(Ve);Gt=i(bn,"Overview"),bn.forEach(o),Ft.forEach(o),mt=h(e),x=a(e,"P",{});var ne=r(x);Jt=i(ne,"The UPerNet model was proposed in "),se=a(ne,"A",{href:!0,rel:!0});var wn=r(se);Yt=i(wn,"Unified Perceptual Parsing for Scene Understanding"),wn.forEach(o),Vt=i(ne,`
by Tete Xiao, Yingcheng Liu, Bolei Zhou, Yuning Jiang, Jian Sun. UPerNet is a general framework to effectively segment
a wide range of concepts from images, leveraging any vision backbone like `),Ue=a(ne,"A",{href:!0});var yn=r(Ue);Zt=i(yn,"ConvNeXt"),yn.forEach(o),Kt=i(ne," or "),xe=a(ne,"A",{href:!0});var $n=r(xe);Qt=i($n,"Swin"),$n.forEach(o),eo=i(ne,"."),ne.forEach(o),ht=h(e),Pe=a(e,"P",{});var Nn=r(Pe);to=i(Nn,"The abstract from the paper is the following:"),Nn.forEach(o),dt=h(e),Ee=a(e,"P",{});var Sn=r(Ee);Ze=a(Sn,"EM",{});var kn=r(Ze);oo=i(kn,"Humans recognize the visual world at multiple levels: we effortlessly categorize scenes and detect objects inside, while also identifying the textures and surfaces of the objects along with their different compositional parts. In this paper, we study a new task called Unified Perceptual Parsing, which requires the machine vision systems to recognize as many visual concepts as possible from a given image. A multi-task framework called UPerNet and a training strategy are developed to learn from heterogeneous image annotations. We benchmark our framework on Unified Perceptual Parsing and show that it is able to effectively segment a wide range of concepts from images. The trained networks are further applied to discover visual knowledge in natural scenes."),kn.forEach(o),Sn.forEach(o),ut=h(e),B=a(e,"IMG",{src:!0,alt:!0,width:!0}),gt=h(e),X=a(e,"SMALL",{});var At=r(X);no=i(At,"UPerNet framework. Taken from the "),Ce=a(At,"A",{href:!0});var Un=r(Ce);ao=i(Un,"original paper"),Un.forEach(o),ro=i(At,"."),At.forEach(o),_t=h(e),C=a(e,"P",{});var Re=r(C);so=i(Re,"This model was contributed by "),ie=a(Re,"A",{href:!0,rel:!0});var xn=r(ie);io=i(xn,"nielsr"),xn.forEach(o),lo=i(Re,". The original code is based on OpenMMLab\u2019s mmsegmentation "),le=a(Re,"A",{href:!0,rel:!0});var Pn=r(le);co=i(Pn,"here"),Pn.forEach(o),po=i(Re,"."),Re.forEach(o),vt=h(e),A=a(e,"H2",{class:!0});var qt=r(A);G=a(qt,"A",{id:!0,class:!0,href:!0});var En=r(G);Ke=a(En,"SPAN",{});var Cn=r(Ke);w(ce.$$.fragment,Cn),Cn.forEach(o),En.forEach(o),fo=h(qt),Qe=a(qt,"SPAN",{});var jn=r(Qe);mo=i(jn,"Resources"),jn.forEach(o),qt.forEach(o),bt=h(e),je=a(e,"P",{});var Tn=r(je);ho=i(Tn,"A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with UPerNet."),Tn.forEach(o),wt=h(e),J=a(e,"UL",{});var zt=r(J);pe=a(zt,"LI",{});var It=r(pe);uo=i(It,"Demo notebooks for UPerNet can be found "),fe=a(It,"A",{href:!0,rel:!0});var Fn=r(fe);go=i(Fn,"here"),Fn.forEach(o),_o=i(It,"."),It.forEach(o),vo=h(zt),j=a(zt,"LI",{});var ke=r(j);Te=a(ke,"A",{href:!0});var An=r(Te);bo=i(An,"UperNetForSemanticSegmentation"),An.forEach(o),wo=i(ke," is supported by this "),me=a(ke,"A",{href:!0,rel:!0});var qn=r(me);yo=i(qn,"example script"),qn.forEach(o),$o=i(ke," and "),he=a(ke,"A",{href:!0,rel:!0});var zn=r(he);No=i(zn,"notebook"),zn.forEach(o),So=i(ke,"."),ke.forEach(o),zt.forEach(o),yt=h(e),Fe=a(e,"P",{});var In=r(Fe);ko=i(In,"If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),In.forEach(o),$t=h(e),q=a(e,"H2",{class:!0});var Dt=r(q);Y=a(Dt,"A",{id:!0,class:!0,href:!0});var Dn=r(Y);et=a(Dn,"SPAN",{});var On=r(et);w(de.$$.fragment,On),On.forEach(o),Dn.forEach(o),Uo=h(Dt),tt=a(Dt,"SPAN",{});var Mn=r(tt);xo=i(Mn,"Usage"),Mn.forEach(o),Dt.forEach(o),Nt=h(e),Ae=a(e,"P",{});var Ln=r(Ae);Po=i(Ln,"UPerNet is a general framework for semantic segmentation. It can be used with any vision backbone, like so:"),Ln.forEach(o),St=h(e),w(ue.$$.fragment,e),kt=h(e),V=a(e,"P",{});var Ot=r(V);Eo=i(Ot,"To use another vision backbone, like "),qe=a(Ot,"A",{href:!0});var Rn=r(qe);Co=i(Rn,"ConvNeXt"),Rn.forEach(o),jo=i(Ot,", simply instantiate the model with the appropriate backbone:"),Ot.forEach(o),Ut=h(e),w(ge.$$.fragment,e),xt=h(e),ze=a(e,"P",{});var Hn=r(ze);To=i(Hn,"Note that this will randomly initialize all the weights of the model."),Hn.forEach(o),Pt=h(e),z=a(e,"H2",{class:!0});var Mt=r(z);Z=a(Mt,"A",{id:!0,class:!0,href:!0});var Wn=r(Z);ot=a(Wn,"SPAN",{});var Bn=r(ot);w(_e.$$.fragment,Bn),Bn.forEach(o),Wn.forEach(o),Fo=h(Mt),nt=a(Mt,"SPAN",{});var Xn=r(nt);Ao=i(Xn,"UperNetConfig"),Xn.forEach(o),Mt.forEach(o),Et=h(e),U=a(e,"DIV",{class:!0});var T=r(U);w(ve.$$.fragment,T),qo=h(T),I=a(T,"P",{});var He=r(I);zo=i(He,"This is the configuration class to store the configuration of an "),Ie=a(He,"A",{href:!0});var Gn=r(Ie);Io=i(Gn,"UperNetForSemanticSegmentation"),Gn.forEach(o),Do=i(He,`. It is used to
instantiate an UperNet model according to the specified arguments, defining the model architecture. Instantiating a
configuration with the defaults will yield a similar configuration to that of the UperNet
`),be=a(He,"A",{href:!0,rel:!0});var Jn=r(be);Oo=i(Jn,"openmmlab/upernet-convnext-tiny"),Jn.forEach(o),Mo=i(He," architecture."),He.forEach(o),Lo=h(T),D=a(T,"P",{});var We=r(D);Ro=i(We,"Configuration objects inherit from "),De=a(We,"A",{href:!0});var Yn=r(De);Ho=i(Yn,"PretrainedConfig"),Yn.forEach(o),Wo=i(We,` and can be used to control the model outputs. Read the
documentation from `),Oe=a(We,"A",{href:!0});var Vn=r(Oe);Bo=i(Vn,"PretrainedConfig"),Vn.forEach(o),Xo=i(We," for more information."),We.forEach(o),Go=h(T),w(K.$$.fragment,T),Jo=h(T),Q=a(T,"DIV",{class:!0});var Lt=r(Q);w(we.$$.fragment,Lt),Yo=h(Lt),O=a(Lt,"P",{});var Be=r(O);Vo=i(Be,"Serializes this instance to a Python dictionary. Override the default "),Me=a(Be,"A",{href:!0});var Zn=r(Me);Zo=i(Zn,"to_dict()"),Zn.forEach(o),Ko=i(Be,`. Returns:
`),at=a(Be,"CODE",{});var Kn=r(at);Qo=i(Kn,"Dict[str, any]"),Kn.forEach(o),en=i(Be,": Dictionary of all the attributes that make up this configuration instance,"),Be.forEach(o),Lt.forEach(o),T.forEach(o),Ct=h(e),M=a(e,"H2",{class:!0});var Rt=r(M);ee=a(Rt,"A",{id:!0,class:!0,href:!0});var Qn=r(ee);rt=a(Qn,"SPAN",{});var ea=r(rt);w(ye.$$.fragment,ea),ea.forEach(o),Qn.forEach(o),tn=h(Rt),st=a(Rt,"SPAN",{});var ta=r(st);on=i(ta,"UperNetForSemanticSegmentation"),ta.forEach(o),Rt.forEach(o),jt=h(e),E=a(e,"DIV",{class:!0});var Xe=r(E);w($e.$$.fragment,Xe),nn=h(Xe),it=a(Xe,"P",{});var oa=r(it);an=i(oa,"UperNet framework leveraging any vision backbone e.g. for ADE20k, CityScapes."),oa.forEach(o),rn=h(Xe),P=a(Xe,"DIV",{class:!0});var ae=r(P);w(Ne.$$.fragment,ae),sn=h(ae),L=a(ae,"P",{});var Ge=r(L);ln=i(Ge,"The "),Le=a(Ge,"A",{href:!0});var na=r(Le);cn=i(na,"UperNetForSemanticSegmentation"),na.forEach(o),pn=i(Ge," forward method, overrides the "),lt=a(Ge,"CODE",{});var aa=r(lt);fn=i(aa,"__call__"),aa.forEach(o),mn=i(Ge," special method."),Ge.forEach(o),hn=h(ae),w(te.$$.fragment,ae),dn=h(ae),w(oe.$$.fragment,ae),ae.forEach(o),Xe.forEach(o),this.h()},h(){l(d,"name","hf:doc:metadata"),l(d,"content",JSON.stringify(va)),l(u,"id","upernet"),l(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(u,"href","#upernet"),l(g,"class","relative group"),l(W,"id","overview"),l(W,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(W,"href","#overview"),l(F,"class","relative group"),l(se,"href","https://arxiv.org/abs/1807.10221"),l(se,"rel","nofollow"),l(Ue,"href","convnext"),l(xe,"href","swin"),fa(B.src,un="https://huggingface.co/datasets/huggingface/documentation-images/blob/main/transformers/model_doc/upernet_architecture.jpg")||l(B,"src",un),l(B,"alt","drawing"),l(B,"width","600"),l(Ce,"href","https://arxiv.org/abs/1807.10221"),l(ie,"href","https://huggingface.co/nielsr"),l(ie,"rel","nofollow"),l(le,"href","https://github.com/open-mmlab/mmsegmentation/blob/master/mmseg/models/decode_heads/uper_head.py"),l(le,"rel","nofollow"),l(G,"id","resources"),l(G,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(G,"href","#resources"),l(A,"class","relative group"),l(fe,"href","https://github.com/NielsRogge/Transformers-Tutorials/tree/master/UPerNet"),l(fe,"rel","nofollow"),l(Te,"href","/docs/transformers/v4.26.1/en/model_doc/upernet#transformers.UperNetForSemanticSegmentation"),l(me,"href","https://github.com/huggingface/transformers/tree/main/examples/pytorch/semantic-segmentation"),l(me,"rel","nofollow"),l(he,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/semantic_segmentation.ipynb"),l(he,"rel","nofollow"),l(Y,"id","usage"),l(Y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Y,"href","#usage"),l(q,"class","relative group"),l(qe,"href","convnext"),l(Z,"id","transformers.UperNetConfig"),l(Z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Z,"href","#transformers.UperNetConfig"),l(z,"class","relative group"),l(Ie,"href","/docs/transformers/v4.26.1/en/model_doc/upernet#transformers.UperNetForSemanticSegmentation"),l(be,"href","https://huggingface.co/openmmlab/upernet-convnext-tiny"),l(be,"rel","nofollow"),l(De,"href","/docs/transformers/v4.26.1/en/main_classes/configuration#transformers.PretrainedConfig"),l(Oe,"href","/docs/transformers/v4.26.1/en/main_classes/configuration#transformers.PretrainedConfig"),l(Me,"href","/docs/transformers/v4.26.1/en/main_classes/configuration#transformers.PretrainedConfig.to_dict"),l(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ee,"id","transformers.UperNetForSemanticSegmentation"),l(ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ee,"href","#transformers.UperNetForSemanticSegmentation"),l(M,"class","relative group"),l(Le,"href","/docs/transformers/v4.26.1/en/model_doc/upernet#transformers.UperNetForSemanticSegmentation"),l(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,c){t(document.head,d),p(e,k,c),p(e,g,c),t(g,u),t(u,v),y(f,v,null),t(g,_),t(g,H),t(H,Bt),p(e,ft,c),p(e,F,c),t(F,W),t(W,Ye),y(re,Ye,null),t(F,Xt),t(F,Ve),t(Ve,Gt),p(e,mt,c),p(e,x,c),t(x,Jt),t(x,se),t(se,Yt),t(x,Vt),t(x,Ue),t(Ue,Zt),t(x,Kt),t(x,xe),t(xe,Qt),t(x,eo),p(e,ht,c),p(e,Pe,c),t(Pe,to),p(e,dt,c),p(e,Ee,c),t(Ee,Ze),t(Ze,oo),p(e,ut,c),p(e,B,c),p(e,gt,c),p(e,X,c),t(X,no),t(X,Ce),t(Ce,ao),t(X,ro),p(e,_t,c),p(e,C,c),t(C,so),t(C,ie),t(ie,io),t(C,lo),t(C,le),t(le,co),t(C,po),p(e,vt,c),p(e,A,c),t(A,G),t(G,Ke),y(ce,Ke,null),t(A,fo),t(A,Qe),t(Qe,mo),p(e,bt,c),p(e,je,c),t(je,ho),p(e,wt,c),p(e,J,c),t(J,pe),t(pe,uo),t(pe,fe),t(fe,go),t(pe,_o),t(J,vo),t(J,j),t(j,Te),t(Te,bo),t(j,wo),t(j,me),t(me,yo),t(j,$o),t(j,he),t(he,No),t(j,So),p(e,yt,c),p(e,Fe,c),t(Fe,ko),p(e,$t,c),p(e,q,c),t(q,Y),t(Y,et),y(de,et,null),t(q,Uo),t(q,tt),t(tt,xo),p(e,Nt,c),p(e,Ae,c),t(Ae,Po),p(e,St,c),y(ue,e,c),p(e,kt,c),p(e,V,c),t(V,Eo),t(V,qe),t(qe,Co),t(V,jo),p(e,Ut,c),y(ge,e,c),p(e,xt,c),p(e,ze,c),t(ze,To),p(e,Pt,c),p(e,z,c),t(z,Z),t(Z,ot),y(_e,ot,null),t(z,Fo),t(z,nt),t(nt,Ao),p(e,Et,c),p(e,U,c),y(ve,U,null),t(U,qo),t(U,I),t(I,zo),t(I,Ie),t(Ie,Io),t(I,Do),t(I,be),t(be,Oo),t(I,Mo),t(U,Lo),t(U,D),t(D,Ro),t(D,De),t(De,Ho),t(D,Wo),t(D,Oe),t(Oe,Bo),t(D,Xo),t(U,Go),y(K,U,null),t(U,Jo),t(U,Q),y(we,Q,null),t(Q,Yo),t(Q,O),t(O,Vo),t(O,Me),t(Me,Zo),t(O,Ko),t(O,at),t(at,Qo),t(O,en),p(e,Ct,c),p(e,M,c),t(M,ee),t(ee,rt),y(ye,rt,null),t(M,tn),t(M,st),t(st,on),p(e,jt,c),p(e,E,c),y($e,E,null),t(E,nn),t(E,it),t(it,an),t(E,rn),t(E,P),y(Ne,P,null),t(P,sn),t(P,L),t(L,ln),t(L,Le),t(Le,cn),t(L,pn),t(L,lt),t(lt,fn),t(L,mn),t(P,hn),y(te,P,null),t(P,dn),y(oe,P,null),Tt=!0},p(e,[c]){const Se={};c&2&&(Se.$$scope={dirty:c,ctx:e}),K.$set(Se);const ct={};c&2&&(ct.$$scope={dirty:c,ctx:e}),te.$set(ct);const pt={};c&2&&(pt.$$scope={dirty:c,ctx:e}),oe.$set(pt)},i(e){Tt||($(f.$$.fragment,e),$(re.$$.fragment,e),$(ce.$$.fragment,e),$(de.$$.fragment,e),$(ue.$$.fragment,e),$(ge.$$.fragment,e),$(_e.$$.fragment,e),$(ve.$$.fragment,e),$(K.$$.fragment,e),$(we.$$.fragment,e),$(ye.$$.fragment,e),$($e.$$.fragment,e),$(Ne.$$.fragment,e),$(te.$$.fragment,e),$(oe.$$.fragment,e),Tt=!0)},o(e){N(f.$$.fragment,e),N(re.$$.fragment,e),N(ce.$$.fragment,e),N(de.$$.fragment,e),N(ue.$$.fragment,e),N(ge.$$.fragment,e),N(_e.$$.fragment,e),N(ve.$$.fragment,e),N(K.$$.fragment,e),N(we.$$.fragment,e),N(ye.$$.fragment,e),N($e.$$.fragment,e),N(Ne.$$.fragment,e),N(te.$$.fragment,e),N(oe.$$.fragment,e),Tt=!1},d(e){o(d),e&&o(k),e&&o(g),S(f),e&&o(ft),e&&o(F),S(re),e&&o(mt),e&&o(x),e&&o(ht),e&&o(Pe),e&&o(dt),e&&o(Ee),e&&o(ut),e&&o(B),e&&o(gt),e&&o(X),e&&o(_t),e&&o(C),e&&o(vt),e&&o(A),S(ce),e&&o(bt),e&&o(je),e&&o(wt),e&&o(J),e&&o(yt),e&&o(Fe),e&&o($t),e&&o(q),S(de),e&&o(Nt),e&&o(Ae),e&&o(St),S(ue,e),e&&o(kt),e&&o(V),e&&o(Ut),S(ge,e),e&&o(xt),e&&o(ze),e&&o(Pt),e&&o(z),S(_e),e&&o(Et),e&&o(U),S(ve),S(K),S(we),e&&o(Ct),e&&o(M),S(ye),e&&o(jt),e&&o(E),S($e),S(Ne),S(te),S(oe)}}}const va={local:"upernet",sections:[{local:"overview",title:"Overview"},{local:"resources",title:"Resources"},{local:"usage",title:"Usage"},{local:"transformers.UperNetConfig",title:"UperNetConfig"},{local:"transformers.UperNetForSemanticSegmentation",title:"UperNetForSemanticSegmentation"}],title:"UPerNet"};function ba(R){return ma(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ua extends ia{constructor(d){super();la(this,d,ba,_a,ca,{})}}export{Ua as default,va as metadata};
